`define FORWARD_LEFT out3 <= 1 
`define REVERSE_LEFT out2 <= 1
`define FORWARD_RIGHT out0 <= 1 
`define REVERSE_RIGHT out1 <= 1 
`define SWNE 4'b1111
`define SWN  4'b1110
`define SNE  4'b1011
`define SENSE_SWN dird <= 4'b0001
`define SENSE_SNE dird <= 4'b0100
`define SEND_0 dird <= `SWNE 

module charli(sysclk,reset,ind,out0,out1,out2,out3,dird,ind);

input sysclk,reset;
input ind;
output out0;
output out1;
output out2;
output out3;
output dird;
wire [3:0] ind;
reg out0;
reg out1;
reg out2;
reg out3;
reg [3:0] dird; 
reg stepleft;
reg [3:0] touch;

always
  begin
   `SEND_0;
  @(posedge sysclk);
   while (!touch) //(touch == 0)
    begin
      if (stepleft)
        `FORWARD_LEFT;
      else
        `FORWARD_RIGHT;
     @(posedge sysclk);
     @(posedge sysclk);
      stepleft <= ~stepleft;
      `SENSE_SNE;
     @(posedge sysclk);
      touch <= (`SWNE^dird)&(~ind);
      `SEND_0;
     @(posedge sysclk); 
   end
   stepleft <= ~stepleft;
   touch <= 0;
  @(posedge sysclk);
   while (!touch) //(touch == 0)
    begin
      if (stepleft)
        `REVERSE_LEFT;
      else
        `REVERSE_RIGHT;
     @(posedge sysclk);
     @(posedge sysclk);
      stepleft <= ~stepleft;
      `SENSE_SWN;
     @(posedge sysclk);
      touch <= (`SWNE^dird)&(~ind);
      `SEND_0;
     @(posedge sysclk); 
    end
   stepleft <= ~stepleft;
   touch <= 0;
  end
endmodule


