module slow_div_system(pb,ready,x,y,r2,sysclk,reset);
input pb;
input x;
input y;
input sysclk,reset;
output r1;
output r2;
wire pb;
wire [7:0] x,y;
reg [7:0] r1;
reg [7:0] r2;

  always
    begin
      @(posedge sysclk) #1;//`IDLE);
        r1 <= @(posedge sysclk) x;
        if (pb)
          begin
           @(posedge sysclk) #1;//`INIT);
            r2 <= @(posedge sysclk) 0;
            while (r1 >= y)
              begin
                @(posedge sysclk) #1;//`COMPUTE1);
                  r1 <= @(posedge sysclk) r1 - y;
                @(posedge sysclk) #1;//`COMPUTE2);
                  r2 <= @(posedge sysclk) r2 + 1;
              end
          end
    end
endmodule
